﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using C1.Win.C1FlexGrid;
namespace prj_rowParentNode
{
    public partial class Form1 : Form
    {
        int row;
        public Form1()
        {
            InitializeComponent();          
        }
        private void AddDirectory(string dir, int level)
        {
            // add this director.
            string thisDir = Path.GetFileName(dir);
            if (thisDir.Length == 0) { thisDir = dir; }
            _flex.AddItem(thisDir);
            //make this new row a node
            Row row = _flex.Rows[_flex.Rows.Count - 1];
            row.IsNode = true;
            //set node level
            Node nd = row.Node;
            nd.Level = level;
            // add files in this director.
            int cnt = 0;
            Row r;

            foreach (string file in Directory.GetFiles(dir))
            {
                _flex.AddItem(Path.GetFileName(file).ToLower());
                //mark the row without child row as node
                r = _flex.Rows[_flex.Rows.Count - 1];
                r.IsNode = true;
                r.Node.Level = level + 1;
                cnt = cnt + 1;
                if (cnt > 10) break;
            }
            // add subdirectories (up to level 4.
            if (level <= 4)
            {
                cnt = 0;
                foreach (string subdir in Directory.GetDirectories(dir))
                {
                    AddDirectory(subdir, level + 1);
                    cnt = cnt + 1;
                    if (cnt > 10) break;
                }
            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            _flex.Cols.Fixed = 0;
            _flex.Cols.Count = 1;
            _flex.Rows.Count = 1;
            _flex.ExtendLastCol = true;
            _flex.Styles.Normal.TextAlign = TextAlignEnum.LeftCenter;
            _flex.Styles.Normal.Border.Style = BorderStyleEnum.None;

            // Initialize outline tree.
            _flex.Tree.Column = 0;
            _flex.Tree.Style = TreeStyleFlags.SimpleLeaf;
            _flex.Tree.LineColor = Color.DarkBlue;

            // Populate the grid.
            AddDirectory(Environment.GetFolderPath(Environment.SpecialFolder.Desktop), 0);
        }
        private void _flex_MouseClick(object sender, MouseEventArgs e)
        {
            _flex.HitTest(e.Location);
            HitTestInfo hti = _flex.HitTest(e.X, e.Y);
            row = hti.Row;
            MessageBox.Show("Row clicked: "+row.ToString());
            MessageBox.Show("Root node index: "+GetRootNode(row).ToString());
            MessageBox.Show("Parent node index: "+GetParentNode(row).ToString());

        }
        int GetRootNode(int rowIndex)
        {
            int nodeIndex = -1;
            foreach (Node node in _flex.Nodes)
            {
                if (node.Row.Index < rowIndex)
                    nodeIndex = node.Row.Index;
                else
                    break;
            }
            return nodeIndex;
        }
        int GetParentNode(int rowIndex)
        {
            var row = _flex.Rows[rowIndex];
            if(row.IsNode)
            {
                row.IsNode = true;
                var node = row.Node;
                Node parent = node.GetNode(NodeTypeEnum.Parent);
                Row r = parent.Row;
                int parentIndex = r.Index;
                return (parentIndex);
            }
            else
            {
                var node = row.Node;
                Node parent = node.GetNode(NodeTypeEnum.Parent);
                Row r = parent.Row;
                int parentIndex = r.Index;
                return (parentIndex);
            }
        }
    }
}
